#ifndef __BASE_ATTRIBUT__
#define __BASE_ATTRIBUT__

using std::ostream;
using namespace blitz ;


using XMLIOSERVER::XMLIOIncompatibleTypeException;

namespace XMLIOSERVER
{
   class BaseAttribut
   {
      public:

         virtual string getName(void) const = 0  ;
         virtual ostream & print(ostream& o) const = 0  ;

         friend ostream& operator <<(ostream& o,const BaseAttribut& Attr) { return (Attr.print(o)) ; }

         bool hasId(void) const { return (true); }

         virtual string getId(void) const { return (getName()); } ;

         virtual void assignValue(const BaseAttribut*) = 0;
         virtual void setFromString(const std::string str) = 0;
         virtual bool _hasValue() const = 0;

#define  SETTER_AND_GETTER(TYPE) \
         virtual void setValue(const TYPE & value)          { error_set() ; }\
         virtual void setValue(const Array<TYPE,1>& value)  { error_set() ; }\
         virtual void setValue(const Array<TYPE,2>& value)  { error_set() ; }\
         virtual void setValue(const Array<TYPE,3>& value)  { error_set() ; }\
         virtual void getValue(TYPE & value)         const  { error_get() ; }\
         virtual void getValue(Array<TYPE,1>& value) const  { error_get() ; }\
         virtual void getValue(Array<TYPE,2>& value) const  { error_get() ; }\
         virtual void getValue(Array<TYPE,3>& value) const  { error_get() ; }

         SETTER_AND_GETTER(int)
         SETTER_AND_GETTER(bool)
         SETTER_AND_GETTER(double)
         SETTER_AND_GETTER(char)
         SETTER_AND_GETTER(string)

#undef SETTER_AND_GETTER

         static void error_set(void)
         { throw XMLIOIncompatibleTypeException("BaseAttribut::set<type> > Setting value type is incompatible with attribut type"); }

         static void error_get(void)
         { throw XMLIOIncompatibleTypeException("BaseAttribut::set<type> >Getting value type is incompatible with attribut type"); }

   }; //class BaseAttribut
} // namespace XMLIOSERVER

#endif //__BASE_ATTRIBUT__

